#include<iostream>
#include<vector>
#include<deque>
#include<algorithm>
#define _USE_MATH_DEFINES
#include<cmath>
#include<cstdlib>
#include<string>

using namespace std;

int main() {
    while (true) {
        int N;
        cin >> N;
        if (N == 0)
            return 0;
        vector<int> inVec(N);
        vector<vector<pair<int, bool>> > tempVec(N, vector<pair<int, bool>>(0));
        for (int i = 0; i < N; ++i) {
            cin >> inVec[i];
            int ti = i + inVec[i];
            if (ti < N) {
                tempVec[ti].push_back(make_pair(i, true));
                //cout << "ti " << ti << " " << i << endl;
            }
            ti = i - inVec[i];
            if (ti >= 0) {
                tempVec[ti].push_back(make_pair(i, false));
                //cout << "ti " << ti << " " << i << endl;
            }
        }
        vector<vector<int>> edges(N, vector<int>(0));
        for (int i = 0; i < N; ++i) {
            for (int j = 0; j < tempVec[i].size(); ++j) {
                for (int k = j + 1; k < tempVec[i].size(); ++k) {
                    if (tempVec[i][j].second == tempVec[i][k].second)
                        continue;
                    int a = tempVec[i][j].first;
                    int b = tempVec[i][k].first;
                    //cout << i << " Adding edge " << a << " " << b << endl;
                    edges[a].push_back(b);
                    edges[b].push_back(a);
                }
            }
        }
        vector<bool> visited(N, false);
        deque<int> q;
        q.push_back(0);
        visited[0] = true;
        while (!q.empty()) {
            int cur = q.front();
            q.pop_front();

            for (int edge: edges[cur]) {
                //cout << "Edges " << edge << endl;
                if (!visited[edge]) {
                    visited[edge] = true;
                    q.push_back(edge);
                    //cout << "Pushing " << edge;
                }
            }
        }

        for (int i = N - 1; i >= 0; --i) {
            if (visited[i]) {
                cout << i << endl;
                break;
            }
        }
    }
    return 0;
}
