#include<iostream>
#include<vector>
#include<deque>
#include<algorithm>
#define _USE_MATH_DEFINES
#include<cmath>
#include<cstdlib>
#include<string>
#include<map>

using namespace std;

struct T {
    int price, amounts;
    T() {}
    T(int price, int amounts) :price(price), amounts(amounts) {}
    bool operator< (T& other) {
        return price < other.price;
    }
};

int main() {
    while (true) {
        int L, S, M, D, B;
        cin >> L >> S >> M >> D >> B;
        if (L == 0)
            return 0;
        // FIRST RUN
        vector<T> vecA;
        vector<T> vecB;
        vector<int> aPrices;
        vector<int> bPrices;
        map<int, int> m;
        int price;
        for (int i = 0; i < S; ++i) {
            cin >> price;
            aPrices.push_back(price);
        }
        for (int i = 0; i < M; ++i) {
            cin >> price;
            bPrices.push_back(price);
        }
        //cout << "read a" << endl;
        for (int priceA: aPrices) {
            for (int priceB: bPrices) {
                if (m.find(priceA + priceB) != m.end()) {
                    ++m[priceA + priceB];
                } else {
                    m[priceA + priceB] = 1;
                }
            }
        }
        for (map<int,int>::value_type& val: m) {
            vecA.push_back(T(val.first, val.second));
        }
        //cout << "sorting a" << endl;
        sort(vecA.begin(), vecA.end());

        // SECOND RUN
        m.clear();
        aPrices = vector<int>();
        bPrices = vector<int>();
        for (int i = 0; i < D; ++i) {
            cin >> price;
            aPrices.push_back(price);
        }
        for (int i = 0; i < B; ++i) {
            cin >> price;
            bPrices.push_back(price);
        }
        //cout << "read b" << endl;
        for (int priceA: aPrices) {
            for (int priceB: bPrices) {
                if (m.find(priceA + priceB) != m.end()) {
                    ++m[priceA + priceB];
                } else {
                    m[priceA + priceB] = 1;
                }
            }
        }
        for (map<int,int>::value_type& val: m) {
            vecB.push_back(T(val.first, val.second));
        }
        //cout << "sorting B" << endl;
        sort(vecB.begin(), vecB.end());

        /*cout << "ALIST" << endl;
        for (auto elem: vecA) {
            cout << elem.price << " " << elem.amounts << endl;
        }
        cout << "BLIST" << endl;
        for (auto elem: vecB) {
            cout << elem.price << " " << elem.amounts << endl;
        }
        cout << endl;*/

        int aPtr = 0;
        int bPtr = vecB.size() - 1;
        long long tempTotalA = 0;
        long long totalA = 0;
        long long sum = 0;
        while (aPtr < vecA.size() && bPtr >= 0) {
            T a = vecA[aPtr];
            T b = vecB[bPtr];

            if (a.price + b.price > L) {
                --bPtr;
                totalA += tempTotalA;
                tempTotalA = 0;
                continue;
            }

            //cout << "ADD " << a.price << " " << b.price << endl;
            sum += (totalA + a.amounts) * b.amounts;
            tempTotalA += a.amounts;
            ++aPtr;

            if (aPtr >= vecA.size()) {
                --bPtr;
                totalA += tempTotalA;
                while (bPtr >= 0) {
                    b = vecB[bPtr];
                    //cout << "ADD " << a.price << " " << b.price << endl;
                    sum += totalA * b.amounts;
                    --bPtr;
                }
                break;

                /*totalA += tempTotalA;
                tempTotalA = 0;*/
            }
        }
        cout << sum << endl;
    }
    return 0;
}
